{ Copyright (c)1989 Ross Neilson Wentworth, All Rights Reserved }
{$A+,B-,D+,E+,F-,I+,L+,N+,O-,R-,S-,V-}
Unit Numbers;

Interface

Uses
  Keyboard;
    
Const
  DeletingChar : Char = #32;

Function Commas(L : LongInt) : String;

Function HexLong(Number : LongInt) : String;

Function HexWord(Number : Word) : String;

Function HexByte(Number : Byte) : String;

Function IntStr(I : Integer) : String;

Function WordStr(W : Word) : String;

Function LongStr(L : LongInt) : String;

Function StrInt(Line : String) : Integer;

Function StrWord(Line : String) : Word;

Function StrLong(Line : String) : LongInt;

Function ReadHexWord : Word;

Function ReadHexLong : LongInt;

Function ReadHexByte : Byte;

Implementation

Function Commas(L : LongInt) : String;

Var
  S1 : String;
  S2 : String;
  Index : Integer;

Begin
  Str(L:0,S1);
  S2 := '';
  While S1 <> '' Do
  Begin
    Index := Length(S1) - 2;
    S2 := ',' + Copy(S1,Index,3) + S2;
    Delete(S1,Index,3);
  End;
  If Pos(',',S2) = 1 Then Delete(S2,1,1);                 { leading comma   }
  If (L < 0) And (Pos(',',S2) = 2) Then Delete(S2,2,1);   { - leading comma }
  Commas := S2;
End;

Function HexLong(Number : LongInt) : String; External;

Function HexWord(Number : Word) : String; External;

Function HexByte(Number : Byte) : String; External;

Function IntStr(I : Integer) : String;

Var
  Temp : String;

Begin
  Str(I,Temp);
  IntStr := Temp;
End;

Function WordStr(W : Word) : String;

Var
  Temp : String;

Begin
  Str(W,Temp);
  WordStr := Temp;
End;

Function LongStr(L : LongInt) : String;

Var
  Temp : String;

Begin
  Str(L,Temp);
  LongStr := Temp;
End;

Function StrInt(Line : String) : Integer;

Var
  I : Integer;
  Result : Integer;

Begin
  Val(Line,I,Result);
  StrInt := I;
End;

Function StrWord(Line : String) : Word;

Var
  W : Word;
  Result : Integer;

Begin
  Val(Line,W,Result);
  StrWord := W;
End;

Function StrLong(Line : String) : LongInt;

Var
  L : LongInt;
  Result : Integer;

Begin
  Val(Line,L,Result);
  StrLong := L;
End;

Function ReadHex(Digits : Integer) : String;

Var
  Temp : String;
  Ch   : Char;

Begin
  Temp := '';
  Repeat
    Ch := UpCase(Chr(ReadWord));
    Case Ch Of
      #8 : If Temp <> '' Then
           Begin
             Dec(Temp[0]);
             Write(#8,DeletingChar,#8);
           End;
     #13 : If Length(Temp) = Digits Then
           Begin
             ReadHex := '$'+Temp;
             Exit;
           End;
     '0'..'9','A'..'F' : If Length(Temp) < Digits Then
           Begin
             Temp := Temp + Ch;
             Write(Ch);
           End
    End;
  Until FALSE;
End;

Function ReadHexWord : Word;

Var
  W : Word;
  Result : Integer;

Begin
  Val(ReadHex(4),W,Result);
  ReadHexWord := W;
End;

Function ReadHexByte : Byte;

Var
  B : Byte;
  Result : Integer;

Begin
  Val(ReadHex(2),B,Result);
  ReadHexByte := B;
End;

Function ReadHexLong : LongInt;

Var
  L : LongInt;
  Result : Integer;

Begin
  Val(ReadHex(8),L,Result);
  ReadHexLong := L;
End;

{$L hexstr.obj}

End.

