{ Copyright (c)1989 Ross Neilson Wentworth, All Rights Reserved }
{$A+,B-,D+,E+,F-,I+,L+,N+,O-,R-,S-,V-}
Unit Utility;

Interface

Const
  StdIn  = 0;
  StdOut = 1;
  StdErr = 2;
  StdAux = 3;
  StdPrn = 4;

Function CPU : Integer;

Function DayOfWeek(Year,Month,Day : Word) : Byte;

Function Exists(FileName : String) : Boolean;

Function FileDay(Time : LongInt) : String;

Procedure ReleaseBlock(Segment : Word);

{ Given a segment, releases the memory. }

  InLine($07/            { pop   es      }
         $B4/$49/        { mov   ah,49h  }
         $CD/$21);       { int   21h     }

Function GetDTAVec : Pointer;

{ returns the segment:offset of the DTA }

  InLine($B4/$2F/    { mov   ah,2Fh  }
         $CD/$21/    { int   21h     }
         $89/$D8/    { mov   ax,bx   }
         $8C/$C2);   { mov   dx,es   }

Procedure SetDTAVec(DTA : Pointer);

{ sets the segment:offset of the DTA }

  InLine($8C/$D8/     { mov   ax,ds   }
         $5A/         { pop   dx      }
         $1F/         { pop   ds      }
         $50/         { push  ax      }
         $B4/$1A/     { mov   ah,1Ah  }
         $CD/$21/     { int   21h     }
         $1F);        { pop   ds      }

Function GetBreakStatus : Boolean;

  InLine($B8/$00/$33/     { mov   ax,3300h }
         $CD/$21/         { int   21h      }
         $88/$D0);        { mov   al,dl    }

Procedure SetBreakStatus(Status : Boolean);

  InLine($5A/             { pop   dx       }
         $B8/$01/$33/     { mov   ax,3301h }
         $CD/$21);        { int   21h      }

Function LoWord(Number : LongInt) : Word;

  InLine($58/             { pop   ax       }
         $5B);            { pop   bx       } { throw the high word away }

Function HiWord(Number : LongInt) : Word;

  InLine($58/             { pop   ax       }
         $58);            { pop   ax       }

Function SwapWord(Number : LongInt) : LongInt;

  InLine($5A/             { pop   dx       }
         $58);            { pop   ax       }


Function IsRedirected(Handle : Word) : Boolean;

{ Returns TRUE if the indicated standard device is redirected }

  InLine($5B/            { pop  bx       }
         $B8/$00/$44/    { mov  ax,4400h }
         $CD/$21/        { int  21h      }
         $B0/$01/        { mov  al,1     }
         $D0/$E2/        { shl  dl,1     }
         $1C/$00);       { sbb  al,0     }

Implementation

Uses
  Dos,
  Strings;

Function CPU : Integer; External;  

Function DayOfWeek(Year,Month,Day : Word) : Byte; External;

Function Exists(FileName : String) : Boolean;

Var
  Search : SearchRec;

Begin
  FindFirst(FileName,AnyFile,Search);
  If DosError = 0
    Then Exists := TRUE
  Else Exists := FALSE;
End;

Function FileDay(Time : LongInt) : String;

Var
  Date : DateTime;

Begin
  UnPackTime(Time,Date);
  With Date Do FileDay := ShortDay(DayOfWeek(Year,Month,Day));
End;

{$L cpu.obj}
{$L dow.obj}
End.

